// c printf
#include <cstdio>
// plugin_name_args & plugin_info
#include <gcc-plugin.h>
// pass_data
#include <tree-pass.h>
// 'g' global variable
#include <context.h>

// our pass
#include "pass_mpi_collective.hpp"

/* Global variable required for plugin to execute */
int plugin_is_GPL_compatible;

/* Main entry point for plugin */
int
plugin_init(struct plugin_name_args *plugin_info,
            struct plugin_gcc_version *version)
{
	printf("plugin_init: Entering...\n");
	printf("\tbasever = %s\n", version->basever);
	printf("\tdatestamp = %s\n", version->datestamp);
	printf("\tdevphase = %s\n", version->devphase);
	printf("\trevision = %s\n", version->revision);
	printf("\tconfig = %s\n", version->configuration_arguments);

	printf("\tbase_name = %s\n", plugin_info->base_name);
	printf("\tfull_name = %s\n", plugin_info->full_name);
	for (int i = 0; i < plugin_info->argc; ++i)
		printf("\t\targ %d: %s = %s\n", i, plugin_info->argv[i].key,
		       plugin_info->argv[i].value);
	printf("\tversion = %s\n", plugin_info->version);
	printf("\thelp = %s\n", plugin_info->help);
	printf("\n\n");

	pass_mpi_collective p(g);

	struct register_pass_info pass_info;

	pass_info.pass = &p;
	pass_info.reference_pass_name = "cfg";
	pass_info.ref_pass_instance_number = 0;
	pass_info.pos_op = PASS_POS_INSERT_AFTER;

	register_callback(plugin_info->base_name,
	                  PLUGIN_PASS_MANAGER_SETUP,
	                  NULL,
	                  &pass_info);

	return 0;
}
